#ifndef _ADVTTY_H
#define _ADVTTY_H

#define AD_DBG	//debug on

#define CDTRDSR         004000000000
//jinxin added to debug
#include <linux/module.h>
#include <linux/fs.h> 
#include <asm/uaccess.h> 
#define  MOD_NAME  "advtty"
#ifdef AD_DBG
/* Print trace message */
#define TRACE \
    if (_DebugLevel >= AD_DEBUG_INFO) \
    	printk("%s: %s(): line %d\n", MOD_NAME, __FUNCTION__, __LINE__)
#else
/* no trace */
#define TRACE 
#endif
//jinxin added to debug end

#include "vttydef.h"

#if (LINUX_VERSION_CODE < VERSION_CODE(2,6,0))
#define CLEAR_FUNC 	advtty_module_exit
#define CLEAR_FUNC_RET	void
#else
#define CLEAR_FUNC 	advtty_module_exit
#define CLEAR_FUNC_RET	static void __exit
#endif


#if (LINUX_VERSION_CODE < VERSION_CODE(2,6,0))
#define INIT_FUNC 	advtty_module_init
#define INIT_FUNC_RET	int
#else
#define INIT_FUNC 	advtty_module_init
#define INIT_FUNC_RET	static int __init
#endif


#if (LINUX_VERSION_CODE < VERSION_CODE(2,6,0))
#define DRV_VAR         (&advar_sdriver)
#define DRV_VAR_P(x)	advar_sdriver.x
#else
#define DRV_VAR         (advar_sdriver)
#define DRV_VAR_P(x)    (advar_sdriver->x)
#define DRV_VAR_OPS(x)	(advar_sdriver->ops->x)
#endif

#if (LINUX_VERSION_CODE < VERSION_CODE(2,6,20))  
#ifndef INIT_WORK
#define INIT_WORK(_work, _func, _data){	\
	(_work)->routine = _func;\
	(_work)->data = _data;\
	}
#endif
#else
#ifndef INIT_WORK
#define INIT_WORK(_work, _func){	\
	(_work)->routine = _func;\
	}
#endif
#endif

#ifndef set_current_state
#define	set_current_state(x) 		current->state = x
#endif


#if (LINUX_VERSION_CODE < VERSION_CODE(2,6,0))
#define IRQ_RET void
#define IRQ_RETVAL(x)
#else
#define IRQ_RET irqreturn_t
#endif

#if (LINUX_VERSION_CODE < VERSION_CODE(2,6,0))
#if (LINUX_VERSION_CODE >= VERSION_CODE(2,4,0)) // >=2.4.0
#define	ADQ_TASK(queue) {\
		MOD_INC_USE_COUNT;\
		if (schedule_task(queue) == 0)\
			MOD_DEC_USE_COUNT;\
	}
#else   // < 2.4.0
#define ADQ_TASK(queue)	queue_task(queue,&tq_scheduler)
#endif
#else   // >=2.6.0
#define	ADQ_TASK(queue)	schedule_work(queue)
#endif

#if (LINUX_VERSION_CODE < VERSION_CODE(2,6,0))
#define AD_MOD_INC	MOD_INC_USE_COUNT
#define AD_MOD_DEC	MOD_DEC_USE_COUNT
#else
#define AD_MOD_INC	try_module_get(THIS_MODULE)
#define AD_MOD_DEC	module_put(THIS_MODULE)
#endif

#if (LINUX_VERSION_CODE >= VERSION_CODE(2,6,0))
#ifndef ASYNC_CALLOUT_ACTIVE
#define ASYNC_CALLOUT_ACTIVE 0
#endif
#endif


#if (LINUX_VERSION_CODE >= VERSION_CODE(2,6,0))
#define AD_TTY_DRV(x)	tty->driver->x
#else
#define AD_TTY_DRV(x)	tty->driver.x
#endif

#if (LINUX_VERSION_CODE >= VERSION_CODE(2,6,5))
#if (LINUX_VERSION_CODE >= VERSION_CODE(2,6,20))
#define AD_SESSION()	tty->session
#else
#define AD_SESSION()	current->signal->session
#endif
#else
#define AD_SESSION()	current->session
#endif

#if (LINUX_VERSION_CODE >= VERSION_CODE(2,6,0))
#if (LINUX_VERSION_CODE >= VERSION_CODE(2,6,24))
static  inline pid_t process_grop(struct task_struct *tsk)
{
	return pid_nr(task_pgrp(tsk));
}
#define AD_CGRP()	process_grop(current)
#else
#define AD_CGRP()	process_group(current)
#endif
#else
#define AD_CGRP()	current->pgrp
#endif

#if (LINUX_VERSION_CODE >= VERSION_CODE(2,6,0))
#define GET_FPAGE	__get_free_page
#else
#define GET_FPAGE	get_free_page
#endif

#if (LINUX_VERSION_CODE >= VERSION_CODE(2,4,0))
#define DOWN(tx_lock, flags)    spin_lock_irqsave(&tx_lock, flags);
#define UP(tx_lock, flags)      spin_unlock_irqrestore(&tx_lock, flags);
#else
#define DOWN(tx_lock, flags)    down(&tx_lock);
#define UP(tx_lock, flags)      up(&tx_lock);
#endif

#ifndef atomic_read
#define atomic_read(v)	v
#endif


#ifndef UCHAR
typedef unsigned char	UCHAR;
#endif

#define AD_DEBUG_OFF        0
#define AD_DEBUG_ERROR      1
#define AD_DEBUG_WARN       2
#define AD_DEBUG_TRACE      3
#define AD_DEBUG_INFO       4
#define AD_DEBUG_LOUD       5

#ifdef AD_DBG
extern int	_DebugLevel;
#define DBGPRINT(level, fmt, args...)			\
{							\
    if((level) <= _DebugLevel)	{			\
	    printk("ADVTTY: %s %d> ", __FUNCTION__, __LINE__);	\
	    printk(KERN_DEBUG fmt, ## args);		\
    }							\
}
#else
#define DBGPRINT(level, fmt, args...)	while(0)
#endif

#endif
