#ifndef _VTTYDEF_H
#define _VTTYDEF_H

#define CF_MAXPORTS                 256
#define CF_VERSION                  "1.20"
#define CF_CMDRSPLEN                84

#define DREQ_FREE_CMDSET            0
#define	DREQ_DEVICE_CMDSET          1
#define	DREQ_DRIVER_CMDSET          2

#define	IOCMD_RETRIEVE              1
#define	IOCMD_RESPONSE              2
#define	IOCMD_CONNECTED             3
#define	IOCMD_DISCONNECTED          4
#define	IOCMD_GET_TTY_STATUS        5

#define	CMD_DRV_TTY_OPEN            1
#define	CMD_DRV_TTY_CLOSE           2

// DREQ command set
#define	DREQ_NOTIFY                 0x26

#define	DREQ_NOTIFY_PARITY          0x01
#define	DREQ_NOTIFY_FRAMING         0x02
#define	DREQ_NOTIFY_HW_OVERRUN      0x04
#define	DREQ_NOTIFY_SW_OVERRUN      0x08
#define	DREQ_NOTIFY_BREAK           0x10
#define	DREQ_NOTIFY_MSR_CHG         0x20

#define	DREQ_CMD_IOCTL              16
#define	DREQ_CMD_FLOWCTRL           17
#define	DREQ_CMD_LSTATUS            19
#define	DREQ_CMD_LINECTRL           18
#define	DREQ_CMD_FLUSH              20
#define	DREQ_CMD_OQUEUE             22
#define	DREQ_CMD_SETBAUD            23
#define	DREQ_CMD_START_BREAK        33
#define	DREQ_CMD_STOP_BREAK         34
#define	DREQ_CMD_START_NOTIFY       36
#define	DREQ_CMD_STOP_NOTIFY        37
#define	DREQ_CMD_HOST               43
#define	DREQ_CMD_PORT_INIT          44
#define	DREQ_CMD_WAIT_OQUEUE        47

#define	DREQ_CMD_IQUEUE             21
#define	DREQ_CMD_XONXOFF            24
#define	DREQ_CMD_PORT_RESET         32
#define	DREQ_CMD_RESENT_TIME        46
#define	DREQ_CMD_TX_FIFO            48
#define DREQ_CMD_SETXON             51
#define DREQ_CMD_SETXOFF            52

#define	DREQ_FLUSH_RX_BUFFER        0
#define	DREQ_FLUSH_TX_BUFFER        1
#define	DREQ_FLUSH_ALL_BUFFER       2

#define	DREQ_IOCTL_B300             0
#define	DREQ_IOCTL_B600             1
#define	DREQ_IOCTL_B1200            2
#define	DREQ_IOCTL_B2400            3
#define	DREQ_IOCTL_B4800            4
#define	DREQ_IOCTL_B7200            5
#define	DREQ_IOCTL_B9600            6
#define	DREQ_IOCTL_B19200           7
#define	DREQ_IOCTL_B38400           8
#define	DREQ_IOCTL_B57600           9
#define	DREQ_IOCTL_B115200          10
#define	DREQ_IOCTL_B230400          11
#define	DREQ_IOCTL_B460800          12
#define	DREQ_IOCTL_B921600          13
#define	DREQ_IOCTL_B150             14
#define	DREQ_IOCTL_B134             15
#define	DREQ_IOCTL_B110             16
#define	DREQ_IOCTL_B75              17
#define	DREQ_IOCTL_B50              18

#define	DREQ_IOCTL_BITS8            3
#define	DREQ_IOCTL_BITS7            2
#define	DREQ_IOCTL_BITS6            1
#define	DREQ_IOCTL_BITS5            0

#define	DREQ_IOCTL_STOP1            0
#define	DREQ_IOCTL_STOP2            4

#define	DREQ_IOCTL_EVEN             8
#define	DREQ_IOCTL_ODD              16
#define	DREQ_IOCTL_MARK             24
#define	DREQ_IOCTL_SPACE            32
#define	DREQ_IOCTL_NONE             0

//jinxin added begin
#define NETLINK_KINIT_LINE	0x01  /* in advtty_open,tell advttyp to initial*/
#define NETLINK_USEND_PID	0x02  /* get pid */
#define NETLINK_KSEND_COMD	0x03  /* send command */
#define NETLINK_DEAL_COMD	0x04  /* recevice ioctl invoke */
#define NETLINK_KSEND_DATA	0x05  /* send data */
#define NETLINK_USEND_DATA	0x06  /* recevice data */
#define NETLINK_KSEND_DATA_OK 	0x07
#define NETLINK_USEND_DATA_OK 	0x08
#define NETLINK_USEND_DATA_NOK 	0x09
#define NETLINK_TTY_STATUS	0x0a
/*
#define NETLINK_RECEIVE_FAILED	0x12
#define NETLINK_WRITE_TRY_AGAIN	0x14
#define NETLINK_RECE_FAILED	0x15
#define NETLINK_DEAL_DELAY_DATA 0x16
#define NETLINK_RECEIVE_OK  	0X17
*/

#define STATE_IDLE                  0
#define STATE_NETCONN               1
#define STATE_NETINIT               2
#define STATE_READY                 3
#define STATE_CLOSING               4
#define STATE_WCLOSING              5
#define STATE_CLOSED                6
#define STATE_NETDOWN               10
//jinxin added end

#ifndef MIN
#define MIN(a,b) ((a) < (b) ? (a) : (b))
#endif

#endif
